## cimg 1.7.9+dfsg

=== examples/Makefile ===
#
#  File        : Makefile
#                ( Makefile for GNU 'make' utility )
#
#  Description : Makefile for compiling CImg-based code on Unix.
#                This file is a part of the CImg Library project.
#                ( http://cimg.eu )
#
#  Copyright   : David Tschumperle
#                ( http://tschumperle.users.greyc.fr/ )
#
#  License     : CeCILL v2.0
#                ( http://www.cecill.info/licences/Licence_CeCILL_V2-en.html )
#
#  This software is governed by the CeCILL  license under French law and
#  abiding by the rules of distribution of free software.  You can  use,
#  modify and/ or redistribute the software under the terms of the CeCILL
#  license as circulated by CEA, CNRS and INRIA at the following URL
#  "http://www.cecill.info".
#
#  As a counterpart to the access to the source code and  rights to copy,
#  modify and redistribute granted by the license, users are provided only
#  with a limited warranty  and the software's author,  the holder of the
#  economic rights,  and the successive licensors  have only  limited
#  liability.
#
#  In this respect, the user's attention is drawn to the risks associated
#  with loading,  using,  modifying and/or developing or reproducing the
#  software by the user in light of its specific status of free software,
#  that may mean  that it is complicated to manipulate,  and  that  also
#  therefore means  that it is reserved for developers  and  experienced
#  professionals having in-depth computer knowledge. Users are therefore
#  encouraged to load and test the software's suitability as regards their
#  requirements in conditions enabling the security of their systems and/or
#  data to be ensured and,  more generally, to use and operate it in the
#  same conditions as regards security.
#
#  The fact that you are presently reading this means that you have had
#  knowledge of the CeCILL license and that you accept its terms.
#

#-------------------------------------------------------
# Define the list of files to be compiled
# (name of the source files without the .cpp extension)
#-------------------------------------------------------

# Files which do not necessarily require external libraries to run.
CIMG_FILES = CImg_demo \
	     captcha \
             curve_editor2d \
	     dtmri_view3d \
	     edge_explorer2d \
	     fade_images \
	     gaussian_fit1d \
             generate_loop_macros \
	     hough_transform2d \
	     image_registration2d \
	     image2ascii \
	     image_surface3d \
	     jawbreaker \
	     mcf_levelsets2d \
	     mcf_levelsets3d \
	     odykill \
	     pde_heatflow2d \
	     pde_TschumperleDeriche2d \
	     plotter1d \
	     radon_transform2d \
	     scene3d \
	     spherical_function3d \
	     tetris \
	     tron \
	     tutorial \
	     wavelet_atrous \
	     use_chlpca \
	     use_draw_gradient \
	     use_nlmeans \
	     use_skeleton \
	     use_RGBclass \

# Files which requires external libraries to run.
CIMG_EXTRA_FILES = use_tiff_stream use_jpeg_buffer

#---------------------------------
# Set correct variables and paths
#---------------------------------
CIMG_VERSION = _cimg_version
X11PATH      = /usr/X11R6
EXEPFX       =
ifeq ($(MSYSTEM),MINGW32)
EXESFX       = .exe
else
EXESFX       =
endif
CXXVER       = $(CXX)
ifeq ($(notdir $(CXX)),g++)
CXXVER       = `$(CXX) -v 2>&1 | tail -n 1`
endif
ifeq ($(notdir $(CXX)),clang++)
CXXVER       = `$(CXX) -v 2>&1 | head -n 1`
endif
ifeq ($(notdir $(CXX)),icpc)
CXXVER       = "icpc \( `$(CXX) -v 2>&1`\)"
CFLAGS       = -I..
LIBS         =
else
CFLAGS       = -I.. -Wall -Wextra -Wfatal-errors
LIBS         = -lm
endif

#--------------------------------------------------
# Set compilation flags allowing to customize CImg
#--------------------------------------------------

# Flags to enable strict code standards
ifeq ($(notdir $(CXX)),icpc)
CIMG_ANSI_CFLAGS = -std=c++11
else
CIMG_ANSI_CFLAGS = -std=c++11 -pedantic
endif

# Flags to enable code debugging.
CIMG_DEBUG_CFLAGS = -Dcimg_verbosity=3 -Dcimg_strict_warnings -g -fsanitize=address

# Flags to enable color output messages.
# (requires a VT100 compatible terminal)
CIMG_VT100_CFLAGS = -Dcimg_use_vt100

# Flags to enable code optimization by the compiler.
ifeq ($(notdir $(CXX)),g++)
CIMG_OPT_CFLAGS = -O2 -mtune=generic
else
ifeq ($(notdir $(CXX)),icpc)
CIMG_OPT_CFLAGS = -fast
else
CIMG_OPT_CFLAGS = -O2
endif
endif

# Flags to enable OpenMP support.
ifeq ($(notdir $(CXX)),icpc)
CIMG_OPENMP_CFLAGS = #-Dcimg_use_openmp -openmp -i-static    # -> Seems to bug the compiler!
else
CIMG_OPENMP_DEFINE = -Dcimg_use_openmp -fopenmp
CIMG_OPENMP_INCDIR =
CIMG_OPENMP_CFLAGS = $(CIMG_OPENMP_DEFINE) $(CIMG_OPENMP_INCDIR)
endif

# Flags to enable OpenCV support.
CIMG_OPENCV_DEFINE = -Dcimg_use_opencv
CIMG_OPENCV_INCDIR = `pkg-config opencv --cflags || echo -I/usr/include/opencv` -I/usr/include/opencv
CIMG_OPENCV_CFLAGS = $(CIMG_OPENCV_DEFINE) $(CIMG_OPENCV_INCDIR)
CIMG_OPENCV_LIBS = `pkg-config opencv --libs || echo -lopencv_core -lopencv_highgui`

# Flags used to disable display capablities of CImg
CIMG_NODISPLAY_CFLAGS = -Dcimg_display=0

# Flags to enable the use of the X11 library.
# (X11 is used by CImg to handle display windows)
CIMG_X11_DEFINE = -Dcimg_display=1
CIMG_X11_INCDIR = `pkg-config --cflags x11 || echo -I/usr/X11R6/include`
CIMG_X11_CFLAGS = $(CIMG_X11_DEFINE) $(CIMG_X11_INCDIR)
CIMG_X11_LIBS = `pkg-config --libs x11 || echo -L/usr/X11R6/lib -lX11` -lpthread

# Flags to enable fast image display, using the XSHM library (when using X11).
# !!! Seems to randomly crash when used on MacOSX and 64bits systems, so use it only when necessary !!!
CIMG_XSHM_CFLAGS = # -Dcimg_use_xshm `pkg-config --cflags xcb-shm`
CIMG_XSHM_LIBS = # `pkg-config --libs xcb-shm || echo -L$(USR)/X11R6/lib -lXext`

# Flags to enable GDI32 display (Windows native).
CIMG_GDI32_DEFINE = -mwindows
CIMG_GDI32_INCDIR =
CIMG_GDI32_CFLAGS = $(CIMG_GDI32_DEFINE) $(CIMG_GDI32_INCDIR)
CIMG_GDI32_LIBS = -lgdi32

# Flags to enable screen mode switching, using the XRandr library (when using X11).
# ( http://www.x.org/wiki/Projects/XRandR )
# !!! Not supported by the X11 server on MacOSX, so do not use it on MacOSX !!!
CIMG_XRANDR_DEFINE = -Dcimg_use_xrandr
CIMG_XRANDR_INCDIR =
CIMG_XRANDR_CFLAGS = $(CIMG_XRANDR_DEFINE) $(CIMG_XRANDR_INCDIR)
CIMG_XRANDR_LIBS = -lXrandr

# Flags to enable native support for PNG image files, using the PNG library.
# ( http://www.libpng.org/ )
CIMG_PNG_DEFINE = -Dcimg_use_png
CIMG_PNG_INCDIR =
CIMG_PNG_CFLAGS = $(CIMG_PNG_DEFINE) $(CIMG_PNG_INCDIR)
CIMG_PNG_LIBS = -lpng -lz

# Flags to enable native support for JPEG image files, using the JPEG library.
# ( http://www.ijg.org/ )
CIMG_JPEG_DEFINE = -Dcimg_use_jpeg
CIMG_JPEG_INCDIR =
CIMG_JPEG_CFLAGS = $(CIMG_JPEG_DEFINE) $(CIMG_JPEG_INCDIR)
CIMG_JPEG_LIBS = -ljpeg

# Flags to enable native support for TIFF image files, using the TIFF library.
# ( http://www.libtiff.org/ )
CIMG_TIFF_DEFINE = -Dcimg_use_tiff
CIMG_TIFF_INCDIR =
CIMG_TIFF_CFLAGS = $(CIMG_TIFF_DEFINE) $(CIMG_TIFF_INCDIR)
CIMG_TIFF_LIBS = -ltiff

# Flags to enable native support for MINC2 image files, using the MINC2 library.
# ( http://en.wikibooks.org/wiki/MINC/Reference/MINC2.0_Users_Guide )
CIMG_MINC2_DEFINE = -Dcimg_use_minc2
CIMG_MINC2_INCDIR = -I${HOME}/local/include
CIMG_MINC2_CFLAGS = $(CIMG_MINC2_DEFINE) $(CIMG_MINC2_INCDIR)
CIMG_MINC2_LIBS = -lminc_io -lvolume_io2 -lminc2 -lnetcdf -lhdf5 -lz -L${HOME}/local/lib

# Flags to enable native support for EXR image files, using the OpenEXR library.
# ( http://www.openexr.com/ )
CIMG_OPENEXR_DEFINE = -Dcimg_use_openexr
CIMG_OPENEXR_INCDIR = -I/usr/include/OpenEXR
CIMG_OPENEXR_CFLAGS = $(CIMG_OPENEXR_DEFINE) $(CIMG_OPENEXR_INCDIR)
CIMG_OPENEXR_LIBS = -lIlmImf -lHalf

# Flags to enable native support for various video files, using the FFMPEG library.
# ( http://www.ffmpeg.org/ )
CIMG_FFMPEG_DEFINE = -Dcimg_use_ffmpeg -D__STDC_CONSTANT_MACROS
CIMG_FFMPEG_INCDIR = -I/usr/include/libavcodec -I/usr/include/libavformat -I/usr/include/libswscale -I/usr/include/ffmpeg
CIMG_FFMPEG_CFLAGS = $(CIMG_FFMPEG_DEFINE) $(CIMG_FFMPEG_INCDIR)
CIMG_FFMPEG_LIBS = -lavcodec -lavformat -lswscale

# Flags to enable native support for compressed .cimgz files, using the Zlib library.
# ( http://www.zlib.net/ )
CIMG_ZLIB_DEFINE = -Dcimg_use_zlib
CIMG_ZLIB_INCDIR = `pkg-config --cflags zlib || echo -I$(USR)/$(INCLUDE)`
CIMG_ZLIB_CFLAGS = $(CIMG_ZLIB_DEFINE) $(CIMG_ZLIB_INCDIR)
CIMG_ZLIB_LIBS = `pkg-config --libs zlib || echo -lz`

# Flags to enable native support for downloading files from the network.
# ( http://curl.haxx.se/libcurl/ )
CIMG_CURL_DEFINE = -Dcimg_use_curl
CIMG_CURL_INCDIR =
CIMG_CURL_CFLAGS = $(CIMG_CURL_DEFINE)
CIMG_CURL_LIBS = -lcurl

# Flags to enable native support of most classical image file formats, using the Magick++ library.
# ( http://www.imagemagick.org/Magick++/ )
CIMG_MAGICK_DEFINE = -Dcimg_use_magick
CIMG_MAGICK_INCDIR = `pkg-config --cflags GraphicsMagick++ || echo -I$(USR)/$(INCLUDE)/GraphicsMagick`
CIMG_MAGICK_CFLAGS = $(CIMG_MAGICK_DEFINE) $(CIMG_MAGICK_INCDIR)
CIMG_MAGICK_LIBS = `pkg-config --libs GraphicsMagick++ || echo -lGraphicsMagick++`

# Flags to enable faster Discrete Fourier Transform computation, using the FFTW3 library
# ( http://www.fftw.org/ )
CIMG_FFTW3_DEFINE = -Dcimg_use_fftw3
CIMG_FFTW3_INCDIR =
CIMG_FFTW3_CFLAGS = $(CIMG_FFTW3_DEFINE) $(CIMG_FFTW3_INCDIR)
ifeq ($(OSTYPE),msys)
CIMG_FFTW3_LIBS = -lfftw3-3
else
CIMG_FFTW3_LIBS = -lfftw3 -lfftw3_threads
endif

# Flags to enable the use of LAPACK routines for matrix computation
# ( http://www.netlib.org/lapack/ )
CIMG_LAPACK_DEFINE = -Dcimg_use_lapack
CIMG_LAPACK_INCDIR =
CIMG_LAPACK_CFLAGS = $(CIMG_LAPACK_DEFINE) $(CIMG_LAPACK_INCDIR)
CIMG_LAPACK_LIBS = -lblas -llapack

# Flags to enable the use of the Board library
# ( http://libboard.sourceforge.net/ )
CIMG_BOARD_DEFINE = -Dcimg_use_board
CIMG_BOARD_INCDIR = -I/usr/include/board
CIMG_BOARD_CFLAGS = $(CIMG_BOARD_DEFINE) $(CIMG_BOARD_INCDIR)
CIMG_BOARD_LIBS = -lboard

# Flags to compile on Sun Solaris
CIMG_SOLARIS_LIBS = -R$(X11PATH)/lib -lrt -lnsl -lsocket

# Flags to compile GIMP plug-ins.
ifeq ($(MSYSTEM),MINGW32)
CIMG_GIMP_CFLAGS = -mwindows
endif

#-------------------------
# Define Makefile entries
#-------------------------
.cpp:
	@echo
	@echo "** Compiling '$* ($(CIMG_VERSION))' with '$(CXXVER)'"
	@echo
	$(CXX) -o $(EXEPFX)$*$(EXESFX) $< $(CFLAGS) $(CONF_CFLAGS) $(LIBS) $(CONF_LIBS)
ifeq ($(STRIP_EXE),true)
	strip $(EXEPFX)$*$(EXESFX)
endif
menu:
	@echo
	@echo "CImg Library $(CIMG_VERSION) : Examples"
	@echo "-----------------------------"
	@echo "  > linux    : Linux/BSD target, X11 display, optimizations disabled."
	@echo "  > dlinux   : Linux/BSD target, X11 display, debug mode."
	@echo "  > olinux   : Linux/BSD target, X11 display, optimizations enabled."
	@echo "  > mlinux   : Linus/BSD target, no display, minimal features, optimizations enabled."
	@echo "  > Mlinux   : Linux/BSD target, X11 display, maximal features, optimizations enabled."
	@echo
	@echo "  > solaris  : Sun Solaris target, X11 display, optimizations disabled."
	@echo "  > dsolaris : Sun Solaris target, X11 display, debug mode."
	@echo "  > osolaris : Sun Solaris target, X11 display, optimizations enabled."
	@echo "  > msolaris : Sun Solaris target, no display, minimal features, optimizations enabled."
	@echo "  > Msolaris : Sun Solaris target, X11 display, maximal features, optimizations enabled."
	@echo
	@echo "  > macosx   : MacOSX target, X11 display, optimizations disabled."
	@echo "  > dmacosx  : MacOSX target, X11 display, debug mode."
	@echo "  > omacosx  : MacOSX target, X11 display, optimizations enabled."
	@echo "  > mmacosx  : MacOSX target, no display, minimal features, optimizations enabled."
	@echo "  > Mmacosx  : MacOSX target, X11 display, maximal features, optimizations enabled."
	@echo
	@echo "  > windows  : Windows target, GDI32 display, optimizations disabled."

=== debian/control ===
Source: cimg
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: math
Priority: optional
Build-Depends: debhelper (>= 10)
Build-Depends-Indep: doxygen (>= 1.8.12),
                     libx11-dev,
                     libxrandr-dev,
                     libgraphicsmagick++1-dev | libmagick++-dev,
                     libfftw3-dev | fftw3-dev,
                     libgimp2.0-dev,
                     libopencv-dev,
                     libminc-dev,
                     libtiff5-dev,
                     libtiffxx5,
                     libcurl4-gnutls-dev | libcurl4-dev,
                     texlive-latex-extra,
                     texlive-fonts-recommended
Standards-Version: 4.0.0
Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/cimg.git/
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/cimg.git
Homepage: http://cimg.sourceforge.net/

Package: cimg-dev
Architecture: all
Depends: libx11-dev,
         libxrandr-dev,
         libopencv-dev,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: xmedcon,
          lapack3-dev,
          cimg-doc,
          cimg-examples,
          libgraphicsmagick++1-dev | libmagick++-dev,
          libfftw3-dev | fftw3-dev,
          libgimp2.0-dev,
          libhighgui-dev,
          libtiff5-dev,
          libtiffxx5
Description: powerful image processing library
 The CImg Library is a C++ toolkit providing simple classes and functions
 to load, save, process and display images in your own C++ code. It consists
 only of a single header file CImg.h that must be included in your program
 source. It contains useful image processing algorithms for loading/saving,
 resizing/rotating, filtering, object drawing (text, lines, faces,
 ellipses, ...), etc.
 .
 Images are instantiated by a class able to represent images up to 4-dimension
 wide (from 1-D scalar signals to 3-D volumes of vector-valued pixels), with
 template pixel types. It depends on a minimal number of libraries : you can
 compile it with only standard C libraries. No need for exotic libraries and
 complex dependencies.

Package: cimg-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
         libjs-jquery
Enhances: cimg-dev
Description: documentation of cimg-dev imaging library
 The CImg Library is a C++ toolkit providing simple classes and functions
 to load, save, process and display images in your own C++ code. It consists
 only of a single header file CImg.h that must be included in your program
 source. It contains useful image processing algorithms for loading/saving,
 resizing/rotating, filtering, object drawing (text, lines, faces,
 ellipses, ...), etc.
 .
 Images are instantiated by a class able to represent images up to 4-dimension
 wide (from 1-D scalar signals to 3-D volumes of vector-valued pixels), with
 template pixel types. It depends on a minimal number of libraries : you can
 compile it with only standard C libraries. No need for exotic libraries and
 complex dependencies.
 .
 This package contains the documentation.

Package: cimg-examples
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Recommends: cimg-dev,
            libgraphicsmagick++1-dev | libmagick++-dev,
            libfftw3-dev | fftw3-dev,
            libgimp2.0-dev,
            libopencv-dev,
            libhighgui-dev
Enhances: cimg-dev,
          cimg-doc
Description: examples for cimg-dev imaging library
 The CImg Library is a C++ toolkit providing simple classes and functions
 to load, save, process and display images in your own C++ code. It consists
 only of a single header file CImg.h that must be included in your program
 source. It contains useful image processing algorithms for loading/saving,
 resizing/rotating, filtering, object drawing (text, lines, faces,
 ellipses, ...), etc.
 .
 Images are instantiated by a class able to represent images up to 4-dimension
 wide (from 1-D scalar signals to 3-D volumes of vector-valued pixels), with
 template pixel types. It depends on a minimal number of libraries : you can
 compile it with only standard C libraries. No need for exotic libraries and
 complex dependencies.
 .
 This package contains examples for the usage of the library.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules for cimg-dev package
# GNU copyright 2009 Andreas Tille <tille@debian.org>

pkg=cimg-dev
examples=cimg-examples
doc=cimg-doc

%:
	dh $@

override_dh_compress:
	dh_compress --exclude=.shtml \
	            --exclude=.pdf \
	            --exclude=.h \
	            --exclude=.cpp \
	            --exclude=.bmp \
	            --exclude=.pgm \
	            --exclude=.ppm \
	            --exclude=Makefile \
	            --exclude=.raw \
	            --exclude=.gmic

override_dh_installdocs:
	dh_installdocs
	find debian/cimg-doc -type f -name "*.html" -exec debian/remove_privacy_violating_js_code \{\} \;

override_dh_auto_test:
	cd examples && $(MAKE) Mlinux "LDFLAGS=-lm -lpthread -lHalf"
	# After test build of examples remove remaining object files
	cd examples && $(MAKE) clean

CHANGEFILES=gaussian_fit1d.cpp \
            use_RGBclass.cpp

override_dh_clean:
	dh_clean
	rm -rf html/latex html/reference html/doxygen_sqlite3.db

override_dh_auto_build:
	dh_auto_build
	cd html && doxygen CImg.doxygen && cd latex && make || true
	# autogenerated makefile lacks a final pdflatex call to get references right (that's why the above '|| true')
	cd html/latex && pdflatex refman

override_dh_install:
	dh_install
	# In gaussian_fit1d.cpp the files is included into itself and thus the current directory needs to be in include path
	cd debian/$(examples)/usr/share/doc/$(pkg)/examples; \
	    sed -i 's?\(CFLAGS[[:space:]=]*-I\)\.\. -Wall -W?\1`pwd` -Wall -W?' Makefile; \
	    for file in $(CHANGEFILES) ; do \
		sed -i "s?#define cimg_plugin \"examples/$$file\"?#define cimg_plugin \"$$file\"?" $$file ; \
	    done
	mv html/reference/* debian/$(doc)/usr/share/doc/cimg-dev/html

override_dh_auto_clean:
	-cd examples && $(MAKE) clean
	dh_clean

=== debian/watch ===
version=4
opts="uversionmangle=s/^(\d)(\d)(\d)$/$1.$2.$3/,repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,repack,compression=xz" \
  https://github.com/dtschump/CImg/releases .*/archive/v\.*(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## cimg 2.3.6+dfsg

=== examples/Makefile ===
#
#  File        : Makefile
#                ( Makefile for GNU 'make' utility )
#
#  Description : Makefile for compiling CImg-based code on Unix.
#                This file is a part of the CImg Library project.
#                ( http://cimg.eu )
#
#  Copyright   : David Tschumperle
#                ( http://tschumperle.users.greyc.fr/ )
#
#  License     : CeCILL v2.0
#                ( http://www.cecill.info/licences/Licence_CeCILL_V2-en.html )
#
#  This software is governed by the CeCILL  license under French law and
#  abiding by the rules of distribution of free software.  You can  use,
#  modify and/ or redistribute the software under the terms of the CeCILL
#  license as circulated by CEA, CNRS and INRIA at the following URL
#  "http://www.cecill.info".
#
#  As a counterpart to the access to the source code and  rights to copy,
#  modify and redistribute granted by the license, users are provided only
#  with a limited warranty  and the software's author,  the holder of the
#  economic rights,  and the successive licensors  have only  limited
#  liability.
#
#  In this respect, the user's attention is drawn to the risks associated
#  with loading,  using,  modifying and/or developing or reproducing the
#  software by the user in light of its specific status of free software,
#  that may mean  that it is complicated to manipulate,  and  that  also
#  therefore means  that it is reserved for developers  and  experienced
#  professionals having in-depth computer knowledge. Users are therefore
#  encouraged to load and test the software's suitability as regards their
#  requirements in conditions enabling the security of their systems and/or
#  data to be ensured and,  more generally, to use and operate it in the
#  same conditions as regards security.
#
#  The fact that you are presently reading this means that you have had
#  knowledge of the CeCILL license and that you accept its terms.
#

#-------------------------------------------------------
# Define the list of files to be compiled
# (name of the source files without the .cpp extension)
#-------------------------------------------------------

# Files which do not necessarily require external libraries to run.
FILES = CImg_demo \
        captcha \
        curve_editor2d \
        dtmri_view3d \
	edge_explorer2d \
	fade_images \
	gaussian_fit1d \
        generate_loop_macros \
	hough_transform2d \
	image_registration2d \
	image2ascii \
	image_surface3d \
	jawbreaker \
	mcf_levelsets2d \
	mcf_levelsets3d \
	odykill \
	pde_heatflow2d \
	pde_TschumperleDeriche2d \
	plotter1d \
	radon_transform2d \
	scene3d \
	spherical_function3d \
	tetris \
	tron \
	tutorial \
	wavelet_atrous \
	use_chlpca \
	use_draw_gradient \
	use_nlmeans \
	use_skeleton \
	use_RGBclass \

# Files which requires external libraries to run.
EXTRA_FILES = use_tiff_stream use_jpeg_buffer

#---------------------------------
# Set correct variables and paths
#---------------------------------
VERSION = `grep 'cimg_version\ ' ../CImg.h | tail -c4 | head -c3`
X11PATH      = /usr/X11R6
EXEPFX       =
ifeq ($(MSYSTEM),MINGW32)
EXESFX       = .exe
else
ifeq ($(MSYSTEM),MINGW64)
EXESFX       = .exe
else
EXESFX       =
endif
endif
CXXVER       = $(CXX)
ifeq ($(notdir $(CXX)),g++)
CXXVER       = `$(CXX) -v 2>&1 | tail -n 1`
endif
ifeq ($(notdir $(CXX)),clang++)
CXXVER       = `$(CXX) -v 2>&1 | head -n 1`
endif
ifeq ($(notdir $(CXX)),icpc)
CXXVER       = "icpc \( `$(CXX) -v 2>&1`\)"
CFLAGS       = -I..
LIBS         =
else
CFLAGS       = -I.. -Wall -Wextra -Wfatal-errors
LIBS         = -lm
endif

#--------------------------------------------------
# Set compilation flags allowing to customize CImg
#--------------------------------------------------

# Flags to enable strict code standards
ifeq ($(notdir $(CXX)),icpc)
ANSI_CFLAGS = -std=c++11
else
ANSI_CFLAGS = -std=c++11 -pedantic
endif

# Flags to enable code debugging.
DEBUG_CFLAGS = -Dcimg_verbosity=3 -Dcimg_strict_warnings -g -fsanitize=address

# Flags to enable color output messages.
# (requires a VT100 compatible terminal)
VT100_CFLAGS = -Dcimg_use_vt100

# Flags to enable code optimization by the compiler.
ifeq ($(notdir $(CXX)),g++)
OPT_CFLAGS = -Ofast -mtune=generic
else
ifeq ($(notdir $(CXX)),icpc)
OPT_CFLAGS = -fast
else
OPT_CFLAGS = -Ofast
endif
endif

# Flags to enable OpenMP support.
ifeq ($(notdir $(CXX)),icpc)
OPENMP_CFLAGS = #-Dcimg_use_openmp -openmp -i-static    # -> Seems to bug the compiler!
else
OPENMP_DEFINE = -Dcimg_use_openmp -fopenmp
OPENMP_INCDIR =
OPENMP_CFLAGS = $(OPENMP_DEFINE) $(OPENMP_INCDIR)
endif

# Flags to enable OpenCV support.
OPENCV_DEFINE = -Dcimg_use_opencv
OPENCV_INCDIR = `pkg-config opencv --cflags || echo -I/usr/include/opencv` -I/usr/include/opencv
OPENCV_CFLAGS = $(OPENCV_DEFINE) $(OPENCV_INCDIR)
OPENCV_LIBS = `pkg-config opencv --libs || echo -lopencv_core -lopencv_highgui`

# Flags used to disable display capablities of CImg
NODISPLAY_CFLAGS = -Dcimg_display=0

# Flags to enable the use of the X11 library.
# (X11 is used by CImg to handle display windows)
X11_DEFINE = -Dcimg_display=1
X11_INCDIR = `pkg-config --cflags x11 || echo -I/usr/X11R6/include`
X11_CFLAGS = $(X11_DEFINE) $(X11_INCDIR)
X11_LIBS = `pkg-config --libs x11 || echo -L/usr/X11R6/lib -lX11` -lpthread

# Flags to enable fast image display, using the XSHM library (when using X11).
# !!! Seems to randomly crash when used on MacOSX and 64bits systems, so use it only when necessary !!!
XSHM_CFLAGS = # -Dcimg_use_xshm `pkg-config --cflags xcb-shm`
XSHM_LIBS = # `pkg-config --libs xcb-shm || echo -L$(USR)/X11R6/lib -lXext`

# Flags to enable GDI32 display (Windows native).
GDI32_DEFINE = -mwindows
GDI32_INCDIR =
GDI32_CFLAGS = $(GDI32_DEFINE) $(GDI32_INCDIR)
GDI32_LIBS = -lgdi32

# Flags to enable screen mode switching, using the XRandr library (when using X11).
# ( http://www.x.org/wiki/Projects/XRandR )
# !!! Not supported by the X11 server on MacOSX, so do not use it on MacOSX !!!
XRANDR_DEFINE = -Dcimg_use_xrandr
XRANDR_INCDIR =
XRANDR_CFLAGS = $(XRANDR_DEFINE) $(XRANDR_INCDIR)
XRANDR_LIBS = -lXrandr

# Flags to enable native support for PNG image files, using the PNG library.
# ( http://www.libpng.org/ )
PNG_DEFINE = -Dcimg_use_png
PNG_INCDIR =
PNG_CFLAGS = $(PNG_DEFINE) $(PNG_INCDIR)
PNG_LIBS = -lpng -lz

# Flags to enable native support for JPEG image files, using the JPEG library.
# ( http://www.ijg.org/ )
JPEG_DEFINE = -Dcimg_use_jpeg
JPEG_INCDIR =
JPEG_CFLAGS = $(JPEG_DEFINE) $(JPEG_INCDIR)
JPEG_LIBS = -ljpeg

# Flags to enable native support for TIFF image files, using the TIFF library.
# ( http://www.libtiff.org/ )
TIFF_DEFINE = -Dcimg_use_tiff
TIFF_INCDIR =
TIFF_CFLAGS = $(TIFF_DEFINE) $(TIFF_INCDIR)
TIFF_LIBS = -ltiff

# Flags to enable native support for MINC2 image files, using the MINC2 library.
# ( http://en.wikibooks.org/wiki/MINC/Reference/MINC2.0_Users_Guide )
MINC2_DEFINE = -Dcimg_use_minc2
MINC2_INCDIR = -I${HOME}/local/include
MINC2_CFLAGS = $(MINC2_DEFINE) $(MINC2_INCDIR)
MINC2_LIBS = -lminc_io -lvolume_io2 -lminc2 -lnetcdf -lhdf5 -lz -L${HOME}/local/lib

# Flags to enable native support for EXR image files, using the OpenEXR library.
# ( http://www.openexr.com/ )
OPENEXR_DEFINE = -Dcimg_use_openexr
OPENEXR_INCDIR = -I/usr/include/OpenEXR
OPENEXR_CFLAGS = $(OPENEXR_DEFINE) $(OPENEXR_INCDIR)
OPENEXR_LIBS = -lIlmImf -lHalf

# Flags to enable native support for various video files, using the FFMPEG library.
# ( http://www.ffmpeg.org/ )
FFMPEG_DEFINE = -Dcimg_use_ffmpeg -D__STDC_CONSTANT_MACROS
FFMPEG_INCDIR = -I/usr/include/libavcodec -I/usr/include/libavformat -I/usr/include/libswscale -I/usr/include/ffmpeg
FFMPEG_CFLAGS = $(FFMPEG_DEFINE) $(FFMPEG_INCDIR)
FFMPEG_LIBS = -lavcodec -lavformat -lswscale

# Flags to enable native support for compressed .cimgz files, using the Zlib library.
# ( http://www.zlib.net/ )
ZLIB_DEFINE = -Dcimg_use_zlib
ZLIB_INCDIR = `pkg-config --cflags zlib || echo -I$(USR)/$(INCLUDE)`
ZLIB_CFLAGS = $(ZLIB_DEFINE) $(ZLIB_INCDIR)
ZLIB_LIBS = `pkg-config --libs zlib || echo -lz`

# Flags to enable native support for downloading files from the network.
# ( http://curl.haxx.se/libcurl/ )
CURL_DEFINE = -Dcimg_use_curl
CURL_INCDIR =
CURL_CFLAGS = $(CURL_DEFINE)
CURL_LIBS = -lcurl

# Flags to enable native support of most classical image file formats, using the Magick++ library.
# ( http://www.imagemagick.org/Magick++/ )
MAGICK_DEFINE = -Dcimg_use_magick
MAGICK_INCDIR = `pkg-config --cflags GraphicsMagick++ || echo -I$(USR)/$(INCLUDE)/GraphicsMagick`
MAGICK_CFLAGS = $(MAGICK_DEFINE) $(MAGICK_INCDIR)
MAGICK_LIBS = `pkg-config --libs GraphicsMagick++ || echo -lGraphicsMagick++`

# Flags to enable faster Discrete Fourier Transform computation, using the FFTW3 library
# ( http://www.fftw.org/ )
FFTW3_DEFINE = -Dcimg_use_fftw3
FFTW3_INCDIR =
FFTW3_CFLAGS = $(FFTW3_DEFINE) $(FFTW3_INCDIR)
ifeq ($(OSTYPE),msys)
FFTW3_LIBS = -lfftw3-3
else
FFTW3_LIBS = -lfftw3 -lfftw3_threads
endif

# Flags to enable the use of LAPACK routines for matrix computation
# ( http://www.netlib.org/lapack/ )
LAPACK_DEFINE = -Dcimg_use_lapack
LAPACK_INCDIR =
LAPACK_CFLAGS = $(LAPACK_DEFINE) $(LAPACK_INCDIR)
LAPACK_LIBS = -lblas -llapack

# Flags to enable the use of the Board library
# ( http://libboard.sourceforge.net/ )
BOARD_DEFINE = -Dcimg_use_board
BOARD_INCDIR = -I/usr/include/board
BOARD_CFLAGS = $(BOARD_DEFINE) $(BOARD_INCDIR)
BOARD_LIBS = -lboard

# Flags to compile on Sun Solaris
SOLARIS_LIBS = -R$(X11PATH)/lib -lrt -lnsl -lsocket

# Flags to compile GIMP plug-ins.
ifeq ($(MSYSTEM),MINGW32)
GIMP_CFLAGS = -mwindows
endif

#-------------------------
# Define Makefile entries
#-------------------------
.cpp:
	@echo
	@echo "** Compiling '$* ($(VERSION))' with '$(CXXVER)'"
	@echo
	$(CXX) -o $(EXEPFX)$*$(EXESFX) $< $(CFLAGS) $(CONF_CFLAGS) $(LIBS) $(CONF_LIBS)
ifeq ($(STRIP_EXE),true)
	strip $(EXEPFX)$*$(EXESFX)
endif
menu:
	@echo
	@echo "CImg Library $(VERSION) : Examples"
	@echo "-----------------------------"
	@echo "  > linux    : Linux/BSD target, X11 display, optimizations disabled."
	@echo "  > dlinux   : Linux/BSD target, X11 display, debug mode."
	@echo "  > olinux   : Linux/BSD target, X11 display, optimizations enabled."
	@echo "  > mlinux   : Linus/BSD target, no display, minimal features, optimizations enabled."
	@echo "  > Mlinux   : Linux/BSD target, X11 display, maximal features, optimizations enabled."
	@echo
	@echo "  > solaris  : Sun Solaris target, X11 display, optimizations disabled."
	@echo "  > dsolaris : Sun Solaris target, X11 display, debug mode."
	@echo "  > osolaris : Sun Solaris target, X11 display, optimizations enabled."
	@echo "  > msolaris : Sun Solaris target, no display, minimal features, optimizations enabled."
	@echo "  > Msolaris : Sun Solaris target, X11 display, maximal features, optimizations enabled."
	@echo
	@echo "  > macosx   : MacOSX target, X11 display, optimizations disabled."
	@echo "  > dmacosx  : MacOSX target, X11 display, debug mode."
	@echo "  > omacosx  : MacOSX target, X11 display, optimizations enabled."
	@echo "  > mmacosx  : MacOSX target, no display, minimal features, optimizations enabled."
	@echo "  > Mmacosx  : MacOSX target, X11 display, maximal features, optimizations enabled."
	@echo
	@echo "  > windows  : Windows target, GDI32 display, optimizations disabled."
	@echo "  > dwindows : Windows target, GDI32 display, debug mode."
	@echo "  > owindows : Windows target, GDI32 display, optimizations enabled."
	@echo "  > mwindows : Windows target, no display, minimal features, optimizations enabled."
	@echo "  > Mwindows : Windows target, GDI32 display, maximal features, optimizations enabled."
	@echo
	@echo "  > clean    : Clean generated files."
	@echo
	@echo "Choose your option :"
	@read CHOICE; echo; $(MAKE) $$CHOICE; echo; echo "> Next time, you can bypass the menu by typing directly 'make $$CHOICE'"; echo;

all: $(FILES)

clean:
	rm -rf *.exe *.o *~ \#* $(FILES) $(EXTRA_FILES)
ifneq ($(EXEPFX),)
	rm -f $(EXEPFX)*
endif

=== debian/changelog ===
cimg (2.3.6+dfsg-1) unstable; urgency=medium

  * New upstream version
  * debhelper 11
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.2.1

 -- Andreas Tille <tille@debian.org>  Tue, 18 Sep 2018 16:52:07 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Uploaders: Andreas Tille <tille@debian.org>
 Section: math
 Priority: optional
-Build-Depends: debhelper (>= 10)
+Build-Depends: debhelper (>= 11~)
 Build-Depends-Indep: doxygen (>= 1.8.12),
                      libx11-dev,
                      libxrandr-dev,
@@ -17,9 +17,9 @@
                      libcurl4-gnutls-dev | libcurl4-dev,
                      texlive-latex-extra,
                      texlive-fonts-recommended
-Standards-Version: 4.0.0
-Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/cimg.git/
-Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/cimg.git
+Standards-Version: 4.2.1
+Vcs-Browser: https://salsa.debian.org/science-team/cimg
+Vcs-Git: https://salsa.debian.org/science-team/cimg.git
 Homepage: http://cimg.sourceforge.net/
 
 Package: cimg-dev

## cimg 2.4.5+dfsg

=== debian/changelog ===
cimg (2.4.5+dfsg-1) unstable; urgency=medium

  [ Jelmer Vernooĳ ]
  * Use secure copyright file specification URI.

  [ Andreas Tille ]
  * New upstream version
  * debhelper 12
  * Standards-Version: 4.3.0
  * Pdf documentation does not build in pbuilder thus drop it

 -- Andreas Tille <tille@debian.org>  Wed, 30 Jan 2019 11:43:23 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Uploaders: Andreas Tille <tille@debian.org>
 Section: math
 Priority: optional
-Build-Depends: debhelper (>= 11~)
+Build-Depends: debhelper (>= 12~)
 Build-Depends-Indep: doxygen (>= 1.8.12),
                      libx11-dev,
                      libxrandr-dev,
@@ -17,7 +17,7 @@
                      libcurl4-gnutls-dev | libcurl4-dev,
                      texlive-latex-extra,
                      texlive-fonts-recommended
-Standards-Version: 4.2.1
+Standards-Version: 4.3.0
 Vcs-Browser: https://salsa.debian.org/science-team/cimg
 Vcs-Git: https://salsa.debian.org/science-team/cimg.git
 Homepage: http://cimg.sourceforge.net/

=== debian/rules ===
--- 
+++ 
@@ -40,9 +40,17 @@
 
 override_dh_auto_build:
 	dh_auto_build
-	cd html && doxygen CImg.doxygen && cd latex && make || true
+	cd html && doxygen CImg.doxygen
+	## since version 2.4.5 for some mysterious reason the generation
+	## of PDF documentation does not work in pbuilder while it generates
+	## nicely on a local testing machine.  The reason are not missing
+	## texlive-* dependencies - it was tried to install all those texlive-*
+	## packages from the testing machine into the pbuilder chroot and it
+	## kept on failing.  So go without the pdf documentation until this
+	## might be fixed
+	# && cd latex && sed -i 's/pdflatex *refman/pdflatex -interaction=batchmode refman || true/' Makefile && make || true
 	# autogenerated makefile lacks a final pdflatex call to get references right (that's why the above '|| true')
-	cd html/latex && pdflatex refman
+	# cd html/latex && pdflatex -interaction=batchmode refman || true
 
 override_dh_install:
 	dh_install

## cimg 2.4.5.1

=== examples/Makefile ===
--- 
+++ 
@@ -83,32 +83,46 @@
 #---------------------------------
 # Set correct variables and paths
 #---------------------------------
-VERSION = `grep 'cimg_version\ ' ../CImg.h | tail -c4 | head -c3`
-X11PATH      = /usr/X11R6
-EXEPFX       =
+VERSION = $(shell grep 'cimg_version\ ' ../CImg.h | tail -c4 | head -c3)
+VERSION1 = $(shell grep 'cimg_version\ ' ../CImg.h | tail -c4 | head -c1)
+VERSION2 = $(shell grep 'cimg_version\ ' ../CImg.h | tail -c3 | head -c1)
+VERSION3 = $(shell grep 'cimg_version\ ' ../CImg.h | tail -c2 | head -c1)
+SVERSION=$(VERSION1).$(VERSION2).$(VERSION3)
+
+X11PATH = /usr/X11R6
+
+EXE_PRE =
+EXE_EXT =
 ifeq ($(MSYSTEM),MINGW32)
-EXESFX       = .exe
-else
+EXE_EXT = .exe
+endif
 ifeq ($(MSYSTEM),MINGW64)
-EXESFX       = .exe
-else
-EXESFX       =
-endif
-endif
-CXXVER       = $(CXX)
-ifeq ($(notdir $(CXX)),g++)
-CXXVER       = `$(CXX) -v 2>&1 | tail -n 1`
-endif
-ifeq ($(notdir $(CXX)),clang++)
-CXXVER       = `$(CXX) -v 2>&1 | head -n 1`
-endif
-ifeq ($(notdir $(CXX)),icpc)
-CXXVER       = "icpc \( `$(CXX) -v 2>&1`\)"
-CFLAGS       = -I..
-LIBS         =
-else
-CFLAGS       = -I.. -Wall -Wextra -Wfatal-errors
-LIBS         = -lm
+EXE_EXT = .exe
+endif
+
+ifeq ($(shell echo $(notdir $(CXX)) | head -c3),g++)
+IS_GCC = 1
+endif
+ifeq ($(shell echo $(notdir $(CXX)) | head -c7),clang++)
+IS_CLANG = 1
+endif
+ifeq ($(shell echo $(notdir $(CXX)) | head -c4),icpc)
+IS_ICPC = 1
+endif
+
+CXXVER = $(CXX)
+CFLAGS = -I.. -Wall -Wextra -Wfatal-errors -Werror=unknown-pragmas -Werror=unused-label
+LIBS = -lm
+ifdef IS_GCC
+CXXVER = $(shell $(CXX) -v 2>&1 | tail -n 1)
+endif
+ifdef IS_CLANG
+CXXVER = $(shell $(CXX) -v 2>&1 | head -n 1)
+endif
+ifdef IS_ICPC
+CXXVER = $(shell $(CXX) -v 2>&1)
+CFLAGS = -I..
+LIBS =
 endif
 
 #--------------------------------------------------
@@ -130,30 +144,30 @@
 VT100_CFLAGS = -Dcimg_use_vt100
 
 # Flags to enable code optimization by the compiler.
-ifeq ($(notdir $(CXX)),g++)
+OPT_CFLAGS = -Ofast
+ifdef IS_GCC
 OPT_CFLAGS = -Ofast -mtune=generic
-else
-ifeq ($(notdir $(CXX)),icpc)
+endif
+ifdef IS_ICPC
 OPT_CFLAGS = -fast
-else
-OPT_CFLAGS = -Ofast
-endif
 endif
 
 # Flags to enable OpenMP support.
-ifeq ($(notdir $(CXX)),icpc)
-OPENMP_CFLAGS = #-Dcimg_use_openmp -openmp -i-static    # -> Seems to bug the compiler!
-else
 OPENMP_DEFINE = -Dcimg_use_openmp -fopenmp
 OPENMP_INCDIR =
 OPENMP_CFLAGS = $(OPENMP_DEFINE) $(OPENMP_INCDIR)
+ifdef IS_ICPC
+OPENMP_CFLAGS = #-Dcimg_use_openmp -openmp -i-static    # -> Seems to bug the compiler!
+endif
+ifdef IS_CLANG
+OPENMP_CFLAGS =
 endif
 
 # Flags to enable OpenCV support.
 OPENCV_DEFINE = -Dcimg_use_opencv
-OPENCV_INCDIR = `pkg-config opencv --cflags || echo -I/usr/include/opencv` -I/usr/include/opencv
+OPENCV_INCDIR = $(shell pkg-config opencv --cflags || echo -I/usr/include/opencv) -I/usr/include/opencv
 OPENCV_CFLAGS = $(OPENCV_DEFINE) $(OPENCV_INCDIR)
-OPENCV_LIBS = `pkg-config opencv --libs || echo -lopencv_core -lopencv_highgui`
+OPENCV_LIBS = $(shell pkg-config opencv --libs || echo -lopencv_core -lopencv_highgui)
 
 # Flags used to disable display capablities of CImg
 NODISPLAY_CFLAGS = -Dcimg_display=0
@@ -161,14 +175,14 @@
 # Flags to enable the use of the X11 library.
 # (X11 is used by CImg to handle display windows)
 X11_DEFINE = -Dcimg_display=1
-X11_INCDIR = `pkg-config --cflags x11 || echo -I/usr/X11R6/include`
+X11_INCDIR = $(shell pkg-config --cflags x11 || echo -I/usr/X11R6/include)
 X11_CFLAGS = $(X11_DEFINE) $(X11_INCDIR)
-X11_LIBS = `pkg-config --libs x11 || echo -L/usr/X11R6/lib -lX11` -lpthread
+X11_LIBS = $(shell pkg-config --libs x11 || echo -L/usr/X11R6/lib -lX11) -lpthread
 
 # Flags to enable fast image display, using the XSHM library (when using X11).
 # !!! Seems to randomly crash when used on MacOSX and 64bits systems, so use it only when necessary !!!
-XSHM_CFLAGS = # -Dcimg_use_xshm `pkg-config --cflags xcb-shm`
-XSHM_LIBS = # `pkg-config --libs xcb-shm || echo -L$(USR)/X11R6/lib -lXext`
+XSHM_CFLAGS = # -Dcimg_use_xshm $(shell pkg-config --cflags xcb-shm)
+XSHM_LIBS = # $(shell pkg-config --libs xcb-shm || echo -L$(USR)/X11R6/lib -lXext)
 
 # Flags to enable GDI32 display (Windows native).
 GDI32_DEFINE = -mwindows
@@ -229,9 +243,9 @@
 # Flags to enable native support for compressed .cimgz files, using the Zlib library.
 # ( http://www.zlib.net/ )
 ZLIB_DEFINE = -Dcimg_use_zlib
-ZLIB_INCDIR = `pkg-config --cflags zlib || echo -I$(USR)/$(INCLUDE)`
+ZLIB_INCDIR = $(shell pkg-config --cflags zlib || echo -I$(USR)/$(INCLUDE))
 ZLIB_CFLAGS = $(ZLIB_DEFINE) $(ZLIB_INCDIR)
-ZLIB_LIBS = `pkg-config --libs zlib || echo -lz`
+ZLIB_LIBS = $(shell pkg-config --libs zlib || echo -lz)
 
 # Flags to enable native support for downloading files from the network.
 # ( http://curl.haxx.se/libcurl/ )
@@ -243,9 +257,9 @@
 # Flags to enable native support of most classical image file formats, using the Magick++ library.
 # ( http://www.imagemagick.org/Magick++/ )
 MAGICK_DEFINE = -Dcimg_use_magick
-MAGICK_INCDIR = `pkg-config --cflags GraphicsMagick++ || echo -I$(USR)/$(INCLUDE)/GraphicsMagick`
+MAGICK_INCDIR = $(shell pkg-config --cflags GraphicsMagick++ || echo -I$(USR)/$(INCLUDE)/GraphicsMagick)
 MAGICK_CFLAGS = $(MAGICK_DEFINE) $(MAGICK_INCDIR)
-MAGICK_LIBS = `pkg-config --libs GraphicsMagick++ || echo -lGraphicsMagick++`
+MAGICK_LIBS = $(shell pkg-config --libs GraphicsMagick++ || echo -lGraphicsMagick++)
 
 # Flags to enable faster Discrete Fourier Transform computation, using the FFTW3 library
 # ( http://www.fftw.org/ )
@@ -266,7 +280,7 @@
 LAPACK_LIBS = -lblas -llapack
 
 # Flags to enable the use of the Board library
-# ( http://libboard.sourceforge.net/ )
+# ( https://github.com/c-koi/libboard )
 BOARD_DEFINE = -Dcimg_use_board
 BOARD_INCDIR = -I/usr/include/board
 BOARD_CFLAGS = $(BOARD_DEFINE) $(BOARD_INCDIR)
@@ -285,15 +299,15 @@
 #-------------------------
 .cpp:
 	@echo
-	@echo "** Compiling '$* ($(VERSION))' with '$(CXXVER)'"
-	@echo
-	$(CXX) -o $(EXEPFX)$*$(EXESFX) $< $(CFLAGS) $(CONF_CFLAGS) $(LIBS) $(CONF_LIBS)
+	@echo "** Compiling '$* ($(SVERSION))' with '$(CXXVER)'"
+	@echo
+	$(CXX) -o $(EXE_PRE)$*$(EXE_EXT) $< $(CFLAGS) $(CONF_CFLAGS) $(LIBS) $(CONF_LIBS)
 ifeq ($(STRIP_EXE),true)
-	strip $(EXEPFX)$*$(EXESFX)
+	strip $(EXE_PRE)$*$(EXE_EXT)
 endif
 menu:
 	@echo
-	@echo "CImg Library $(VERSION) : Examples"
+	@echo "CImg Library $(SVERSION) : Examples"
 	@echo "-----------------------------"
 	@echo "  > linux    : Linux/BSD target, X11 display, optimizations disabled."
 	@echo "  > dlinux   : Linux/BSD target, X11 display, debug mode."
@@ -316,19 +330,3 @@
 	@echo "  > windows  : Windows target, GDI32 display, optimizations disabled."
 	@echo "  > dwindows : Windows target, GDI32 display, debug mode."
 	@echo "  > owindows : Windows target, GDI32 display, optimizations enabled."
-	@echo "  > mwindows : Windows target, no display, minimal features, optimizations enabled."
-	@echo "  > Mwindows : Windows target, GDI32 display, maximal features, optimizations enabled."
-	@echo
-	@echo "  > clean    : Clean generated files."
-	@echo
-	@echo "Choose your option :"
-	@read CHOICE; echo; $(MAKE) $$CHOICE; echo; echo "> Next time, you can bypass the menu by typing directly 'make $$CHOICE'"; echo;
-
-all: $(FILES)
-
-clean:
-	rm -rf *.exe *.o *~ \#* $(FILES) $(EXTRA_FILES)
-ifneq ($(EXEPFX),)
-	rm -f $(EXEPFX)*
-endif
-

=== debian/changelog ===
cimg (2.4.5.1-2+security) unstable; urgency=medium

  * update

 -- Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>  Fri, 06 Aug 2021 09:44:47 +0800

cimg (2.4.5.1-1+security) unstable; urgency=medium

  * fix CVE-2019-13568 CVE-2020-25693

 -- lishengyu <lishengyu@uniontech.com>  Thu, 10 Jun 2021 16:29:55 +0800

## cimg 2.8.4+dfsg

=== examples/Makefile ===
--- 
+++ 
@@ -87,7 +87,7 @@
 VERSION1 = $(shell grep 'cimg_version\ ' ../CImg.h | tail -c4 | head -c1)
 VERSION2 = $(shell grep 'cimg_version\ ' ../CImg.h | tail -c3 | head -c1)
 VERSION3 = $(shell grep 'cimg_version\ ' ../CImg.h | tail -c2 | head -c1)
-SVERSION=$(VERSION1).$(VERSION2).$(VERSION3)
+SVERSION = $(VERSION1).$(VERSION2).$(VERSION3)
 
 X11PATH = /usr/X11R6
 
@@ -123,6 +123,13 @@
 CXXVER = $(shell $(CXX) -v 2>&1)
 CFLAGS = -I..
 LIBS =
+endif
+
+ifdef IS_GCC
+GCC_VER_GTEQ5 = $(shell expr `$(CXX) -dumpversion | cut -f1 -d.` \>= 5)
+ifeq ($(GCC_VER_GTEQ5),1)
+CFLAGS += -Wshadow
+endif
 endif
 
 #--------------------------------------------------
@@ -328,5 +335,3 @@
 	@echo "  > Mmacosx  : MacOSX target, X11 display, maximal features, optimizations enabled."
 	@echo
 	@echo "  > windows  : Windows target, GDI32 display, optimizations disabled."
-	@echo "  > dwindows : Windows target, GDI32 display, debug mode."
-	@echo "  > owindows : Windows target, GDI32 display, optimizations enabled."

=== debian/changelog ===
cimg (2.8.4+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.5.0 (routine-update)
  * debhelper-compat 12 (routine-update)
  * Respect DEB_BUILD_OPTIONS in override_dh_auto_test target (routine-
    update)
  * Remove trailing whitespace in debian/copyright (routine-update)
  * Remove trailing whitespace in debian/rules (routine-update)
  * Add salsa-ci file (routine-update)
  * Trim trailing whitespace.
  * Adapt demo makefile to opencv4
    Closes: #951965

 -- Andreas Tille <tille@debian.org>  Mon, 02 Mar 2020 11:13:46 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Uploaders: Andreas Tille <tille@debian.org>
 Section: math
 Priority: optional
-Build-Depends: debhelper (>= 12~)
+Build-Depends: debhelper-compat (= 12)
 Build-Depends-Indep: doxygen (>= 1.8.12),
                      libx11-dev,
                      libxrandr-dev,
@@ -17,7 +17,7 @@
                      libcurl4-gnutls-dev | libcurl4-dev,
                      texlive-latex-extra,
                      texlive-fonts-recommended
-Standards-Version: 4.3.0
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/science-team/cimg
 Vcs-Git: https://salsa.debian.org/science-team/cimg.git
 Homepage: http://cimg.sourceforge.net/

## cimg 2.9.4+dfsg

=== examples/Makefile ===
--- 
+++ 
@@ -6,7 +6,7 @@
 #                This file is a part of the CImg Library project.
 #                ( http://cimg.eu )
 #
-#  Copyright   : David Tschumperle
+#  Copyright   : David Tschumperlé
 #                ( http://tschumperle.users.greyc.fr/ )
 #
 #  License     : CeCILL v2.0

=== debian/changelog ===
cimg (2.9.4+dfsg-3) unstable; urgency=medium

  * Team Upload.
  * Remove un-needed files from install (Closes: #989617)

 -- Nilesh Patra <nilesh@debian.org>  Mon, 16 Aug 2021 13:35:25 +0530

cimg (2.9.4+dfsg-2) unstable; urgency=medium

  * New upstream version
    Closes: #973770
  * Adapt Files-Excluded to new upstream version
  * Standards-Version: 4.5.1 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit.
  * Fix installation of docs
  * Avoid baseline violation
    Closes: #976927
  * Do not submit any user data to keep privacy

 -- Andreas Tille <tille@debian.org>  Fri, 18 Dec 2020 15:46:15 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Uploaders: Andreas Tille <tille@debian.org>
 Section: math
 Priority: optional
-Build-Depends: debhelper-compat (= 12)
+Build-Depends: debhelper-compat (= 13)
 Build-Depends-Indep: doxygen (>= 1.8.12),
                      libx11-dev,
                      libxrandr-dev,
@@ -17,10 +17,11 @@
                      libcurl4-gnutls-dev | libcurl4-dev,
                      texlive-latex-extra,
                      texlive-fonts-recommended
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/science-team/cimg
 Vcs-Git: https://salsa.debian.org/science-team/cimg.git
 Homepage: http://cimg.sourceforge.net/
+Rules-Requires-Root: no
 
 Package: cimg-dev
 Architecture: all

=== debian/rules ===
--- 
+++ 
@@ -27,9 +27,11 @@
 	find debian/cimg-doc -type f -name "*.html" -exec debian/remove_privacy_violating_js_code \{\} \;
 
 override_dh_auto_test:
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	cd examples && $(MAKE) Mlinux "LDFLAGS=-lm -lpthread -lHalf"
 	# After test build of examples remove remaining object files
 	cd examples && $(MAKE) clean
+endif
 
 CHANGEFILES=gaussian_fit1d.cpp \
             use_RGBclass.cpp
@@ -61,7 +63,8 @@
 		sed -i "s?#define cimg_plugin \"examples/$$file\"?#define cimg_plugin \"$$file\"?" $$file ; \
 	    done
 	mv html/reference/* debian/$(doc)/usr/share/doc/cimg-dev/html
+	find debian -type f -name "_form*" -delete
 
 override_dh_auto_clean:
 	-cd examples && $(MAKE) clean
-	dh_clean 
+	dh_clean
